#ifndef _TX_1C_BOARD_H
#define _TX_1C_BOARD_H

#include "Ai8051U.h"

#define uint unsigned int
#define uchar unsigned char
typedef     unsigned char    u8;
typedef     unsigned int    u16;
typedef     unsigned long    u32;

#define BEEP P23
#define dula P26
#define wela P27

#define adrd P37
#define adwr P36
#define LED_LE P25

//һ
void beep()
{
  BEEP=0;
  delay_ms(1000);
  BEEP=1;
}

//18b20
u8 MinusFlag;       //¶ȸ־01
SBIT(DQ,0xa0/*P2*/,2);  

//
//С |0x80
const unsigned char code segment[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,
                        0x07,0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};

void display(unsigned char num)
{
    P0=segment[num];
    delay_ms(1);
    dula=1;
    delay_ms(1);
    dula=0;
    delay_ms(1);
    P0=0xc0;
    delay_ms(1);
    wela=1;
    delay_ms(1);
    wela=0;
    delay_ms(1);
}

void displayNBytes(unsigned char* buffer,uchar size)
{
    u8 i = 0;
    for (; i < 6 & i < size; i++)
    {        
        dula=0;
        P0=segment[buffer[i]&0x0F] | (buffer[i]&0x80);		//ʾλ
        dula=1;
        dula=0;

        wela=0;
        //ѡڼQ0~5ӦDS1~DS6,Q6ûӣQ7ADC_CS
        P0=(0XFF - 0x80)^(1<<i);
        wela=1;
        wela=0;
        delay(5);
    }
}
void display2Bytes(uchar bai_c,uchar sh_c)			//ʾ
{
   dula=0;
   P0=segment[bai_c];		//ʾλ
   dula=1;
   dula=0;

   wela=0;
   P0=0x7e;
   wela=1;
   wela=0;
   delay(5);

   dula=0;
   P0=segment[sh_c];		//ʾʮλ
   dula=1;
   dula=0;

   wela=0;
   P0=0x7d;
   wela=1;
   wela=0;
   delay(5);

}
void display3Bytes(uchar bai_c,uchar sh_c,uchar g_c)			//ʾ
{  
   P0=segment[bai_c];		//ʾλ
   dula=1;
   dula=0;

   P0=0xfe;
   wela=1;
   wela=0;
   delay(20);

   dula=0;
   P0=segment[sh_c];		//ʾʮλ
   dula=1;
   dula=0;

   wela=0;
   P0=0xfd;
   wela=1;
   wela=0;
   delay(20);

   P0=segment[g_c];		//ʾλ
   dula=1;
   dula=0;

   wela=0;
   P0=0xfb;
   wela=1;
   wela=0;
}

//¶ʾ
void displayTemp(u16 temp)			//ʾ
{
   u8 A1,A2,A2t,A3;
   A1=temp/100;
   A2t=temp%100;
   A2=A2t/10;
   A3=A2t%10;
   dula=0;
   P0=segment[A1];		//ʾλ
   dula=1;
   dula=0;

   wela=0;
   P0=0x7e;
   wela=1;
   wela=0;
   delay(20);

   dula=0;
   P0=segment[A2]|0x80;		//ʾʮλ
   dula=1;
   dula=0;

   wela=0;
   P0=0x7d;
   wela=1;
   wela=0;
   delay(20);

   P0=segment[A3];		//ʾλ
   dula=1;
   dula=0;

   P0=0x7b;
   wela=1;
   wela=0;
}


#if (MAIN_Fosc >= 40000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 36000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 30000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 24000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_();_nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 20000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 18000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 12000000L)
    #define        usrNOP()    _nop_();_nop_();_nop_()
#elif (MAIN_Fosc >= 6000000L)
    #define        usrNOP()    _nop_();_nop_()
#else
    #define        usrNOP()    _nop_()
#endif

//========================================================================
// : void  my_delay_us(u8 us)
// : ʱ
// : us,Ҫʱus, ֻ֧1~255us. 
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void my_delay_us(u8 us)
{
    do{
        usrNOP();
        usrNOP();
    }while(--us);
}

/**************************************
λDS18B20,豸Ƿ
**************************************/
void DS18B20_Reset()
{
    CY = 1;
    while (CY)
    {
        DQ = 0;                     //ͳ͵ƽλź
        my_delay_us(240);              //ʱ480us
        my_delay_us(240);
        DQ = 1;                     //ͷ
        my_delay_us(80);               //ȴ60us
        CY = DQ;                    //
        my_delay_us(240);              //ȴ豸ͷ
        my_delay_us(200);
    }
}

/**************************************
DS18B201ֽ
**************************************/
u8 DS18B20_ReadByte()
{
    u8 i;
    u8 dat = 0;

    for (i=0; i<8; i++)             //8λ
    {
        dat >>= 1;
        DQ = 0;                     //ʼʱƬ
        my_delay_us(1);                //ʱȴ
        DQ = 1;                     //׼
        my_delay_us(1);                //ʱ
        if (DQ) dat |= 0x80;        //ȡ
        my_delay_us(60);               //ȴʱƬ
    }

    return dat;
}

/**************************************
DS18B20д1ֽ
**************************************/
void DS18B20_WriteByte(u8 dat)
{
    char i;

    for (i=0; i<8; i++)             //8λ
    {
        DQ = 0;                     //ʼʱƬ
        my_delay_us(1);                //ʱȴ
        dat >>= 1;                  //ͳ
        DQ = CY;
        my_delay_us(60);               //ȴʱƬ
        DQ = 1;                     //ָ
        my_delay_us(1);                //ָʱ
    }
}


//========================================================================
// : u16 ReadTemperature()
// : ȡ¶Ⱥ
// : none.
// : ¶ֵ.
// 汾: VER1.0
// : 2020-7-30
// ע: 
//========================================================================
u16 ReadTemperature()
{
    u16 TempH, TempL, Temperature;
    
    DS18B20_Reset();                //豸λ
    DS18B20_WriteByte(0xCC);        //ROM
    DS18B20_WriteByte(0x44);        //ʼת
    while (!DQ);                    //ȴת

    DS18B20_Reset();                //豸λ
    DS18B20_WriteByte(0xCC);        //ROM
    DS18B20_WriteByte(0xBE);        //ݴ洢
    TempL = DS18B20_ReadByte();     //¶ȵֽ
    TempH = DS18B20_ReadByte();     //¶ȸֽ
    
    if(TempH & 0xf8)    //жǷλ
    {
        MinusFlag = 1;  //ø־
        Temperature = (TempH<<8) | TempL;
        Temperature = ~Temperature + 1;
        Temperature *= 0.625;       //0.0625 * 101λС
    }
    else
    {
        MinusFlag = 0;  //־
        Temperature = (((TempH<<8) | TempL) * 0.625); //0.0625 * 101λС
    }

    return Temperature;
}

unsigned char  RomCode[8] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
/*******************************************************************/
/*                                                                 */
/* ȡDS18B20 64λ                                           */
/*                                                                 */
/*******************************************************************/
void Read_RomCord(void)
{
    unsigned char j;
    DS18B20_Reset();                //豸λ
    //DS18B20_WriteByte(0xCC);        //ROM
    DS18B20_WriteByte(0x33);
    
    for (j = 0; j < 8; j++)
	{
	  RomCode[j] = DS18B20_ReadByte(); 
	}
}

/*******************************************************************/
/*                                                                 */
/*DS18B20CRC8У                                            */
/*                                                                 */
/*******************************************************************/
uchar CRC8() 
{ 
   uchar i,x; uchar crcbuff;
   
   unsigned char crc=0;
   for(x = 0; x <8; x++)
   {
    crcbuff=RomCode[x];
    for(i = 0; i < 8; i++) 
     { 
      if(((crc ^ crcbuff)&0x01)==0) 
      crc >>= 1; 
       else { 
              crc ^= 0x18;   //CRC=X8+X5+X4+1
              crc >>= 1; 
              crc |= 0x80; 
            }         
      crcbuff >>= 1;       
	 }
   }
     return crc;	
}
//https://www.cnblogs.com/milton/p/16367282.html
u8 DS18B20_Crc(u8 *addr, u8 len)
{
    u8 crc = 0, inbyte, i, mix;
 
    while (len--)
    {
        // inbyte 洢ǰֽ
        inbyte = *addr++;
 
        for (i = 8; i; i--) 
        {
            // ֽCRCӵλλ, , ÿCRCһλ
            // ֵΪ1, CRC 1000 1100 
            // 3,4λͼе, 7λʵ1
            mix = (crc ^ inbyte) & 0x01;
            crc >>= 1;
            if (mix) 
            {
                crc ^= 0x8C;
            }
            inbyte >>= 1;
        }
    }
    return crc;
}
/*******************************************************************/
/*                                                                 */
/*DS18B20CRC8У                                            */
/*                                                                 */
/*******************************************************************/
uchar DS18B20_CRC8() 
{ 
   return DS18B20_Crc(RomCode, 7) == RomCode[7];
}



//LCD1602

SBIT(LCD_B7,0x80/*P0*/,7);


SBIT(LCD_EN,0xb0/*P3*/,4);
SBIT(LCD_RW,0xb0/*P3*/,6);
SBIT(LCD_RS,0xb0/*P3*/,5);

#define LCD_BusData(dat)	P0 = dat
//Lcd1602_ShowStr(0,0,"---1602  demo---");


//========================================================================
// : void lcd1602_delay_ms(u16 ms)
// : ʱ
// : ms,Ҫʱms, ֻ֧1~65535ms. ԶӦʱ.
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void lcd1602_delay_ms(u16 ms)
{
     u16 i;
     do{
          i = MAIN_Fosc / 6000;
          while(--i);
     }while(--ms);
}


/************* LCD1602س	*****************************************************/
//8λݷʷʽ	LCD1602		׼	д	2014-2-21

#define LineLength	16		//16x2

/*
total 2 lines, 16x2= 32
first line address:  0~15
second line address: 64~79

*/

#define C_CLEAR			0x01		//clear LCD
#define C_HOME 			0x02		//cursor go home
#define C_CUR_L			0x04		//cursor shift left after input
#define C_RIGHT			0x05		//picture shift right after input
#define C_CUR_R			0x06		//cursor shift right after input
#define C_LEFT 			0x07		//picture shift left after input
#define C_OFF  			0x08		//turn off LCD
#define C_ON   			0x0C		//turn on  LCD
#define C_FLASH			0x0D		//turn on  LCD, flash 
#define C_CURSOR		0x0E		//turn on  LCD and cursor
#define C_FLASH_ALL		0x0F		//turn on  LCD and cursor, flash
#define C_CURSOR_LEFT	0x10		//single cursor shift left
#define C_CURSOR_RIGHT	0x10		//single cursor shift right
#define C_PICTURE_LEFT	0x10		//single picture shift left
#define C_PICTURE_RIGHT	0x10		//single picture shift right
#define C_BIT8			0x30		//set the data is 8 bits
#define C_BIT4			0x20		//set the data is 4 bits
#define C_L1DOT7		0x30		//8 bits,one line 5*7  dots
#define C_L1DOT10		0x34		//8 bits,one line 5*10 dots
#define C_L2DOT7		0x38		//8 bits,tow lines 5*7 dots
#define C_4bitL2DOT7	0x28		//4 bits,tow lines 5*7 dots
#define C_CGADDRESS0	0x40		//CGRAM address0 (addr=40H+x)
#define C_DDADDRESS0	0x80		//DDRAM address0 (addr=80H+x)


void delayNOP(void)
{
	_nop_();_nop_();_nop_();
	_nop_();
}
void delay1(int ms)
{
 unsigned char y;
  while(ms--)
 {
  for(y = 0; y<250; y++)
  {
   _nop_();
   _nop_();
   _nop_();
   _nop_();
  }
 }
}

/******************************************************************/
/*                                                                */
/*LCDæ״̬                                                   */
/*lcd_busyΪ1ʱæȴlcd-busyΪ0ʱ,Удָݡ     */
/*                                                                */
/******************************************************************/ 

u8 lcd_busy()
 {                          
    u8 result;
    LCD_RS = 0;
//    LCD_RW = 1;
    LCD_EN = 1;
    delayNOP();
    result = (P0&0x80);
    LCD_EN = 0;
    return  result != 0;
 }

/*******************************************************************/
/*                                                                 */
/*дָݵLCD                                                  */
/*RS=LRW=LE=壬D0-D7=ָ롣                             */
/*                                                                 */
/*******************************************************************/

void lcd_wcmd(uchar cmd)

{                          
 //  while(lcd_busy());
    LCD_RS = 0;
 //   LCD_RW = 0;
    LCD_EN = 0;
    _nop_();
    _nop_(); 
    P0 = cmd;
    delayNOP();
    LCD_EN = 1;
    delayNOP();
    LCD_EN = 0;  
	delay1(5);
}

/*******************************************************************/
/*                                                                 */
/*дʾݵLCD                                                  */
/*RS=HRW=LE=壬D0-D7=ݡ                               */
/*                                                                 */
/*******************************************************************/

void lcd_wdat(uchar dat)
{                          
//   while(lcd_busy());
    LCD_RS = 1;
//    LCD_RW = 0;
    LCD_EN = 0;
    P0 = dat;
    delayNOP();
    LCD_EN = 1;
    delayNOP();
    LCD_EN = 0; 
	delay1(5);
}

/*******************************************************************/
/*                                                                 */
/*  LCDʼ趨                                                  */
/*                                                                 */
/*******************************************************************/

void lcd_init()
{ 
    delay1(15);   
    lcd_wcmd(0x01);      //LCDʾ
            
    lcd_wcmd(0x38);      //16*2ʾ5*78λ
    delay1(5);
    lcd_wcmd(0x38);         
    delay1(5);
    lcd_wcmd(0x38);         
    delay1(5);

    lcd_wcmd(0x0c);      //ʾع
    delay1(5);
    lcd_wcmd(0x06);      //ƶ
    delay1(5);
    lcd_wcmd(0x01);      //LCDʾ
    delay1(5);
}

/*******************************************************************/
/*                                                                 */
/*  趨ʾλ                                                   */
/*                                                                 */
/*******************************************************************/

void lcd_pos(uchar pos)
{                          
  lcd_wcmd(pos | 0x80);  //ָ=80+ַ
}

//========================================================================
// : void Lcd1602_ShowStr(u8 row, u8 column, u8 *puts)
// : дһַָСкַ׵ַ
// : row: (01),  column: ڼַ(0~15),  puts: Ҫдַָ.
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void Lcd1602_ShowStr(u8 row, u8 column, u8 *puts)
{
	lcd_wcmd((((row & 1) << 6) + column) | 0x80);
	for ( ;  *puts != 0;  puts++)		//ֹͣ0
	{
		lcd_wdat(*puts);
		if(++column >= LineLength)	break;
	}
}
#ifdef _USE_IAR_COMPILER_
void Lcd1602_ShowStr(u8 row, u8 column, const char *puts)
{
	lcd_wcmd((((row & 1) << 6) + column) | 0x80);
	for ( ;  *puts != 0;  puts++)		//ֹͣ0
	{
		lcd_wdat(*puts);
		if(++column >= LineLength)	break;
	}
}
#endif
//========================================================================
// : void ClearLine(u8 row)
// : 1
// : row: (01)
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void ClearLine(u8 row)
{
	u8 i;
	lcd_wcmd(((row & 1) << 6) | 0x80);
	for(i=0; i<LineLength; i++)	lcd_wdat(' ');
}

//========================================================================
// : void WriteChar(u8 row, u8 column, u8 dat)
// : ָСкַ, дһַ
// : row: (01),  column: ڼַ(0~15),  dat: Ҫдַ.
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void WriteChar(u8 row, u8 column, u8 dat)
{
	lcd_wcmd((((row & 1) << 6) + column) | 0x80);
	lcd_wdat(dat);
}


//24C08
//IOڶ
#define sda P20
#define scl P21
#define SLAW        0xA0
#define SLAR        0xA1

/////////24C08д////////////////////
void i2c_delay1(unsigned char x)
{  unsigned int i;
  for(i=0;i<x;i++);
  ;}
void flash()
{  ;  ; }
void x24c08_init()  //24c08ʼӳ
 {scl=1; flash(); sda=1; flash();}
void start()        //I2C
{sda=1; flash(); scl=1; flash(); sda=0; flash(); scl=0; flash();}
void stop()         //ֹͣI2C
{sda=0; flash(); scl=1; flash(); sda=1; flash();}
void writex(unsigned char j)  //дһֽ
{  unsigned char i,temp;
   temp=j;
   for (i=0;i<8;i++)
   {temp=temp<<1; scl=0; flash(); sda=CY; flash(); scl=1; flash();}
   scl=0; flash(); sda=1; flash();
}
unsigned char readx()   //һֽ
{
   unsigned char i,j,k=0;
   scl=0; flash(); sda=1;
   for (i=0;i<8;i++)
   {  flash(); scl=1; flash();
      if (sda==1) j=1;
      else j=0;
      k=(k<<1)|j;
	  scl=0;}
   flash(); return(k);
}
void clock()         //I2Cʱ
{
   unsigned char i=0;
   scl=1; flash();
   while ((sda==1)&&(i<255))i++;
   scl=0; flash();
}
////////24c02ĵַaddressжȡһֽ/////
unsigned char x24c08_read(unsigned char address)
{
   unsigned char i;
   start(); writex(0xa0);
   clock(); writex(address);
   clock(); start();
   writex(0xa1); clock();
   i=readx(); stop();
   i2c_delay1(10);
   return(i);
}
//////24c02addressַдһֽinfo/////
void x24c08_write(unsigned char address,unsigned char info)
{
   EA=0;
   start(); writex(0xa0);
   clock(); writex(address);
   clock(); writex(info);
   clock(); stop();
   EA=1;
   i2c_delay1(50);
}
//IAP EEPROM


#define     IAP_STANDBY()   IAP_CMD = 0     //IAPֹ
#define     IAP_READ()      IAP_CMD = 1     //IAP
#define     IAP_WRITE()     IAP_CMD = 2     //IAPд
#define     IAP_ERASE()     IAP_CMD = 3     //IAP

#define     IAP_ENABLE()    IAP_CONTR = IAP_EN; IAP_TPS = MAIN_Fosc / 1000000
#define     IAP_DISABLE()   IAP_CONTR = 0; IAP_CMD = 0; IAP_TRIG = 0; IAP_ADDRE = 0xff; IAP_ADDRH = 0xff; IAP_ADDRL = 0xff

#define IAP_EN          (1<<7)
#define IAP_SWBS        (1<<6)
#define IAP_SWRST       (1<<5)
#define IAP_CMD_FAIL    (1<<4)


//========================================================================
// : void DisableEEPROM(void)
// : ֹEEPROM.
// : none.
// : none.
// 汾: V1.0, 2014-6-30
//========================================================================
void DisableEEPROM(void)        //ֹEEPROM
{
    IAP_CONTR = 0;          //ر IAP 
    IAP_CMD = 0;            //Ĵ
    IAP_TRIG = 0;           //Ĵ
    IAP_ADDRE = 0xff;       //ַõ IAP 
    IAP_ADDRH = 0xff;       //ַõ IAP 
    IAP_ADDRL = 0xff;
}

//========================================================================
// : void EEPROM_Trig(void)
// : EEPROM.
// : none.
// : none.
// 汾: V1.0, 2014-6-30
//========================================================================
void EEPROM_Trig(void)
{
    F0 = EA;    //ȫж
    EA = 0;     //ֹж, ⴥЧ
    IAP_TRIG = 0x5A;
    IAP_TRIG = 0xA5;    //5AHA5HIAPĴÿζҪ
                        //A5HIAP
                        //CPUȴIAPɺ󣬲Żִг
    _nop_();   //༶ˮߵָϵͳ4NOP֤IAP_DATA׼
    _nop_();
    _nop_();
    _nop_();
    EA = F0;    //ָȫж
}

//========================================================================
// : void EEPROM_SectorErase(u32 EE_address)
// : һ.
// : EE_address:  ҪEEPROMеһֽڵַ.
// : none.
// 汾: V1.0, 2014-6-30
//========================================================================
void EEPROM_SectorErase(u32 EE_address)
{
    IAP_ENABLE();                       //õȴʱ䣬IAPһξ͹
    IAP_ERASE();                        //, ıʱ
                                        //ֻûֽڲ512ֽ/
                                        //һֽڵַַ
    IAP_ADDRE = (u8)(EE_address >> 16); //ַֽڣַҪıʱ͵ַ
    IAP_ADDRH = (u8)(EE_address >> 8);  //ַֽڣַҪıʱ͵ַ
    IAP_ADDRL = (u8)EE_address;         //ַֽڣַҪıʱ͵ַ
    EEPROM_Trig();                      //EEPROM
    DisableEEPROM();                    //ֹEEPROM
}

//========================================================================
// : void EEPROM_read_n(u32 EE_address,u8 *DataAddress,u8 lenth)
// : Nֽں.
// : EE_address:  ҪEEPROM׵ַ.
//       DataAddress: Ҫݵָ.
//       length:      Ҫĳ
// : 0: дȷ.  1: д볤Ϊ0.  2: дݴ.
// 汾: V1.0, 2014-6-30
//========================================================================
void EEPROM_read_n(u32 EE_address,u8 *DataAddress,u8 length)
{
    IAP_ENABLE();                           //õȴʱ䣬IAPһξ͹
    IAP_READ();                             //ֽڶıʱ
    do
    {
        IAP_ADDRE = (u8)(EE_address >> 16); //͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRH = (u8)(EE_address >> 8);  //͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRL = (u8)EE_address;         //͵ַֽڣַҪıʱ͵ַ
        EEPROM_Trig();                      //EEPROM
        *DataAddress = IAP_DATA;            //
        EE_address++;
        DataAddress++;
    }while(--length);

    DisableEEPROM();
}


//========================================================================
// : u8 EEPROM_write_n(u32 EE_address,u8 *DataAddress,u8 length)
// : дNֽں.
// : EE_address:  ҪдEEPROM׵ַ.
//       DataAddress: Ҫдݵָ.
//       length:      Ҫдĳ
// : 0: дȷ.  1: д볤Ϊ0.  2: дݴ.
// 汾: V1.0, 2014-6-30
//========================================================================
u8 EEPROM_write_n(u32 EE_address,u8 *DataAddress,u8 length)
{
    u8  i;
    u16 j;
    u8  *p;
    
    if(length == 0) return 1;   //Ϊ0

    IAP_ENABLE();                       //õȴʱ䣬IAPһξ͹
    i = length;
    j = EE_address;
    p = DataAddress;
    IAP_WRITE();                            //, ֽд
    do
    {
        IAP_ADDRE = (u8)(EE_address >> 16); //͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRH = (u8)(EE_address >> 8);  //͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRL = (u8)EE_address;         //͵ַֽڣַҪıʱ͵ַ
        IAP_DATA  = *DataAddress;           //ݵIAP_DATAֻݸıʱ
        EEPROM_Trig();                      //EEPROM
        EE_address++;                       //һַ
        DataAddress++;                      //һ
    }while(--length);                       //ֱ

    EE_address = j;
    length = i;
    DataAddress = p;
    i = 0;
    IAP_READ();                             //NֽڲȽ
    do
    {
        IAP_ADDRE = (u8)(EE_address >> 16); //͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRH = (u8)(EE_address >> 8);  //͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRL = (u8)EE_address;         //͵ַֽڣַҪıʱ͵ַ
        EEPROM_Trig();                      //EEPROM
        if(*DataAddress != IAP_DATA)        //ԴݱȽ
        {
            i = 2;
            break;
        }
        EE_address++;
        DataAddress++;
    }while(--length);

    DisableEEPROM();
    return i;
}

//ʹܴ1
#ifdef ENABLE_UART1

#define UART1_BUF_LENGTH    128

//115200
#define Baudrate1   (65536 - MAIN_Fosc / 115200 / 4)
u8  TX1_Cnt;    //ͼ
u8  RX1_Cnt;    //ռ
bit B_TX1_Busy; //æ־
u8  RX1_Buffer[UART1_BUF_LENGTH]; //ջ
//========================================================================
// : void UART1_int (void) interrupt UART1_VECTOR
// : UART1жϺ
// : nine.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
//void UART1_int (void) interrupt 4
INTERRUPT(UART1_int,UART1_VECTOR)
{
    if(RI)
    {
        RI = 0;
        RX1_Buffer[RX1_Cnt] = SBUF;
        if(++RX1_Cnt >= UART1_BUF_LENGTH)   RX1_Cnt = 0;
    }

    if(TI)
    {
        TI = 0;
        B_TX1_Busy = 0;
    }
}
//========================================================================
// : SetTimer2Baudraye(u32 dat)
// : Timer2ʷ
// : dat: Timer2װֵ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void SetTimer2Baudraye(u32 dat)
{
    AUXR &= ~(1<<4);		//Timer stop
    AUXR &= ~(1<<3);	//Timer2 set As Timer
    AUXR |= (1<<2);	//Timer2 set as 1T mode
    T2H = (u8)(dat / 256);
    T2L = (u8)(dat % 256);
    IE2 = (IE2 & ~0x04) | (0 << 2);    //ֹж
    AUXR = (AUXR & ~0x10) | (1 << 4);		//Timer run enable
}

//========================================================================
// : void UART1_config(u8 brt)
// : UART1ʼ
// : brt: ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void UART1_config(u8 brt)
{
    /*********** ʹöʱ2 *****************/
    if(brt == 2)
    {
        AUXR |= S1BRT;	//S1 BRT Use Timer2;
        SetTimer2Baudraye(Baudrate1);
    }

    /*********** ʹöʱ1 *****************/
    else
    {
        TR1 = 0;
        AUXR &= ~S1BRT;		//S1 BRT Use Timer1;
        TMOD &= ~(1<<6);		//Timer1 set As Timer
        AUXR |= (1<<6);		//Timer1 set as 1T mode
        TMOD &= ~0x30;//Timer1_16bitAutoReload;
        TH1 = (u8)(Baudrate1 / 256);
        TL1 = (u8)(Baudrate1 % 256);
        ET1 = 0;    //ֹж
        TR1 = 1;
    }
    /*************************************************/

    SCON = (SCON & 0x3f) | 0x40;    //UART1ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
//  PS  = 1;    //ȼж
    ES  = 1;    //ж
    REN = 1;    //
    P_SW1 &= 0x3f;
    P_SW1 |= 0x00;      //UART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4

    B_TX1_Busy = 0;
    TX1_Cnt = 0;
    RX1_Cnt = 0;
	EA = 1;     //ж
}
//========================================================================
// : void PrintString1(u8 *puts)
// : 1ַ
// : puts:  ַָ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void PrintString1(u8 *puts)
{
    for (; *puts != 0;  puts++)     //ֹͣ0
    {
        SBUF = *puts;
        B_TX1_Busy = 1;
        while(B_TX1_Busy);
    }
}
#ifdef _USE_IAR_COMPILER_
void PrintString1(const char *puts)
{
    for (; *puts != 0;  puts++)     //ֹͣ0
    {
        SBUF = *puts;
        B_TX1_Busy = 1;
        while(B_TX1_Busy);
    }
}
#endif
//ضprintf
PUTCHAR_FUN(){
  SBUF = c;
  B_TX1_Busy = 1;
  while(B_TX1_Busy);
  return c;
}

#endif

#ifdef ENABLE_TIMER0_1HZ
unsigned int secCnt;        //ֵÿ1룬sec1
unsigned int msCnt;
bit B_1s;          //1s־
bit B_1ms;          //1s־
#define Timer0_Reload   (65536UL -(MAIN_Fosc / 1000))       //Timer 0 жƵ, 1000/


INTERRUPT(timer0,TMR0_VECTOR)
{  
    B_1ms = 1;
    msCnt++;
    if(msCnt == 1000){
         secCnt++;
         msCnt = 0;
         B_1s = 1;
    }
}
void initTimer0(){
    AUXR |= 0x80;    //Timer0 set as 1T, 16 bits timer auto-reload, 
    TH0 = (u8)(Timer0_Reload / 256);
    TL0 = (u8)(Timer0_Reload % 256);
    ET0 = 1;    //Timer0 interrupt enable
    TR0 = 1;    //Tiner0 run
    EA = 1;    //ж
    B_1s = 0;
    msCnt = 0;
    secCnt = 0;
}
#endif

// /********************** I2C ************************/
// void I2C_Init(){
//     P_SW2 |= I2C_S1;//I2Cܽѡ00:P2.4,P2.3;01:P1.5,P1.4;11:P3.2,P3.3
//     P_SW2 |= I2C_S0;
//     I2CCFG = 0xc2;  //ʹI2Cģʽ
//     I2CPSCR = 0x00; //MSSPEED[13:6]
//     I2CMSST = 0x00;
//     EA = 1;         //ж

//     sda = 1;
//     NOP(2);
//     scl = 1;
//     NOP(2);
// }
// void I2C_Wait()
// {
//     while (!(I2CMSST & 0x40));
// I2CMSST&=~0x40;
// }

// void I2C_Start()
// {
//     I2CMSCR = 0x01;                         //START
//     I2C_Wait();
// }

// void I2C_SendData(char dat)
// {
//     I2CTXD = dat;                           //дݵݻ
//     I2CMSCR = 0x02;                         //SEND
//     I2C_Wait();
// }

// void I2C_RecvACK()
// {
//     I2CMSCR = 0x03;                         //ͶACK
//     I2C_Wait();
// }

// char I2C_RecvData()
// {
//     I2CMSCR = 0x04;                         //RECV
//     I2C_Wait();
//     return I2CRXD;
// }

// void I2C_SendACK()
// {
//     I2CMSST = 0x00;                         //ACKź
//     I2CMSCR = 0x05;                         //ACK
//     I2C_Wait();
// }

// void I2C_SendNAK()
// {
//     I2CMSST = 0x01;                         //NAKź
//     I2CMSCR = 0x05;                         //ACK
//     I2C_Wait();
// }

// void I2C_Stop()
// {
//     I2CMSCR = 0x06;                         //STOP
//     I2C_Wait();
// }

// void I2C_WriteNbyte(u8 addr, u8 *p, u8 number)  /*  WordAddress,First Data Address,Byte lenth   */
// {
//     I2C_Start();                                //ʼ
//     I2C_SendData(SLAW);                         //豸ַ+д
//     I2C_RecvACK();
//     I2C_SendData(addr);                         //ʹ洢ַ
//     I2C_RecvACK();
//     do
//     {
//         I2C_SendData(*p++);
//         I2C_RecvACK();
//     }
//     while(--number);
//     I2C_Stop();                                 //ֹͣ
// }

// void I2C_ReadNbyte(u8 addr, u8 *p, u8 number)   /*  WordAddress,First Data Address,Byte lenth   */
// {
//     I2C_Start();                                //ʼ
//     I2C_SendData(SLAW);                         //豸ַ+д
//     I2C_RecvACK();
//     I2C_SendData(addr);                         //ʹ洢ַ
//     I2C_RecvACK();
//     I2C_Start();                                //ʼ
//     I2C_SendData(SLAR);                         //豸ַ+
//     I2C_RecvACK();
//     do
//     {
//         *p = I2C_RecvData();
//         p++;
//         if(number != 1) I2C_SendACK();          //send ACK
//     }
//     while(--number);
//     I2C_SendNAK();                              //send no ACK	
//     I2C_Stop();                                 //ֹͣ
// }
#endif